import { HttpModule } from '@nestjs/axios';
import { Module } from '@nestjs/common';
import * as https from 'https';
import { ConfigModule } from '../config/config.module';
import { FileService } from '../shared/services/file.service';
import { FilesController } from './files.controller';

@Module({
  imports: [ConfigModule, HttpModule.register({ httpsAgent: new https.Agent({ rejectUnauthorized: false }) })],
  providers: [FileService],
  controllers: [FilesController],
})
export class FilesModule {}
