import { INestApplication } from '@nestjs/common';
import { DocumentBuilder, SwaggerModule } from '@nestjs/swagger';

const title: string = 'RSA Back API';
const description: string =
  '## Client REST permettant de requêter les controllers du Back.\r\n\
_Pour requêter les requêtes authentifiées (avec un cadenas), il est nécessaire de fournir un token à Swagger._\r\n\r\n\
**Pour cela, il faut :**\r\n\
- Utiliser la requête `/auth/login` pour récupérer un `access token` valide.\r\n\r\n\
- Copier/Coller la valeur de `access token` via le bouton <span class="btn authorize unlocked" style="font-size:11px; padding:3px;"><strong>Authorize</strong> <svg width="15" height="17" style="padding-top:8px;"><svg viewBox="0 0 20 20"><path d="M15.8 8H14V5.6C14 2.703 12.665 1 10 1 7.334 1 6 2.703 6 5.6V6h2v-.801C8 3.754 8.797 3 10 3c1.203 0 2 .754 2 2.199V8H4c-.553 0-1 .646-1 1.199V17c0 .549.428 1.139.951 1.307l1.197.387C5.672 18.861 6.55 19 7.1 19h5.8c.549 0 1.428-.139 1.951-.307l1.196-.387c.524-.167.953-.757.953-1.306V9.199C17 8.646 16.352 8 15.8 8z"></path></svg></svg></span> de swagger, précédé de `Bearer `.\r\n\r\n\
#### Plus d\'informations dans la documentation du projet.';
const API: string = 'api-docs';

const options = new DocumentBuilder().setTitle(title).setDescription(description).addBearerAuth().build();

export class SwaggerDocumentProvider {
  static use(app: INestApplication): void {
    const document = SwaggerModule.createDocument(app, options);
    SwaggerModule.setup(API, app, document);
  }
}
